var assessment = requirejs.config({
	context: "assessment",
	baseUrl: path,
	paths: {
		'jquery': 'jquery',
		'jquery.mobile': 'lib/jquery/jquery.mobile',
		'jquery.highlight': 'plugins/jquery.highlight',
		'widgets': 'widgets',
		'views': 'views',
		'plugins': 'plugins',
		'controllers': 'controllers'
	},
	shim: {
		'jquery.highlight': {
			deps: ['jquery'],
			exports: 'jQuery.fn.highlight'
		},
		'jquery.mobile': {
			deps: ['jquery'],
			exports: 'jQuery'
		}
	}
});
assessment(['controllers/AssessmentUI', 'widgets/Header', 'widgets/SubHeader', 'widgets/SlidingMenu', 'plugins/domReady'], function(AssessmentUI, Header, SubHeader, SlidingMenu, domReady) {
	if (typeof jQuery != "undefined") {
		jQuery.ajaxSetup({
			dataFilter: function(jsonString, type) {
				var result = jsonString;
				if (type == "json") {
					result = JSONUtil.removeTaintedValue(result);
				}
				return result;
			}
		});
	};
	domReady(function() {
		var mainHeader = new Header({
			title: jQuery("header").find(".navbar-title").html(),
			controlsDisabled: true,
		});
		jQuery("header").append(mainHeader.domNode);
		var subHeader = new SubHeader({});
		jQuery("main").prepend(subHeader.domNode);
		var sideMenu = new SlidingMenu({
			hideOnNavigate: true
		});
		jQuery(".main-container").append(sideMenu.domNode);
		AssessmentUI.init({
			menuWidget: sideMenu
		});
		var pageCount = AssessmentUI.getPageCount();
		/*
		 * generate a list item for each page (i.e. Page 1, Page 2, etc.)
		 * 
		 */
		sideMenu.createNavigationList();
		var navigationCallback = function(pageNum) {
			AssessmentUI.goToPage(pageNum);
		};
		for (var i = 1; i <= pageCount; i++) {
			var callback = function(pageNum) {
				return function() {
					navigationCallback(pageNum);
				};
			};
			sideMenu.generateAssessmentNavItem("Page " + i, i, callback(i), AssessmentEngine.isPageCompleted(i));
		}
		sideMenu.setActiveNavElement(null, "assessment-page-1");
		sideMenu.displayNavigationList();
	});
});
