// common should be requested at the head of each view as it contains paths to other libraries and widgets
require([
	'../config'
], function() {
	require([
		'controllers/TreeController',
		'controllers/ProgressController',
		'controllers/NavigationController',
		'controllers/RichMediaController',
		'controllers/BreadCrumbController',
		'controllers/ContentController',
		'widgets/Header',
		'widgets/BreadcrumbsTrail',
		'widgets/SlidingMenu',
		'plugins/domReady'
	], function(TreeController,
		ProgressController,
		NavigationController,
		RichMediaController,
		BreadCrumbController,
		ContentController,
		Header,
		BreadcrumbsTrail,
		SlidingMenu,
		domReady) {
		domReady(function() {
			var contentController =  new ContentController();

			var myHeader = new Header({});
			jQuery("header").append(myHeader.domNode);
			
			var breadcrumbsTrail = new BreadcrumbsTrail({});
			jQuery(breadcrumbsTrail.domNode).hide();
			jQuery("header nav").append(breadcrumbsTrail.domNode);

			var slidingMenu = new SlidingMenu({
				hideOnNavigate : true
			});
			jQuery(".main-container").append(slidingMenu.domNode);

			/*
			 * If the ViewerController does not have a current object it means
			 * that there is no leaf node under the selected object and
			 * therefore no content to display.
			 */
			if (!ViewerController.current) { return; }
			
			var navigationController = new NavigationController({
				slidingMenu : slidingMenu
			});

			var treeController = new TreeController({
				menuWidget : slidingMenu,
				navigationController : navigationController
			});
			
			slidingMenu.setNavigationController(navigationController);
			slidingMenu.setTreeController(treeController);
			slidingMenu.setContentController(contentController);
			
			breadcrumbsTrail.setTreeController(treeController);
			
			new ProgressController();
			new RichMediaController();
			new BreadCrumbController();

			// get current page url and navigate to it, will
			// trigger an event
			// inside Content Controller
			var url = ViewerController.urlMap[ViewerController.current.uniqueId];
			ViewerController.events.navigate.fire(ViewerController.current, url);
		});
	});
});