define("widgets/Overlay", [
 "plugins/text!widgets/templates/Overlay.html"
], function(template) {
    var Overlay = {
        domNode: null,
        parentNode: null,
        initInstance: function(args) {
            if (!this.domNode && !this.parentNode) {
                jQuery.extend(this, args);
                var overlayTemplate = jQuery(template)
                    .clone();
                this.domNode = jQuery(overlayTemplate)
                    .get();
                this.parentNode.append(this.domNode);
            }
        },
        updateInstance: function(args) {
            /* remove the overlay from the existing location and place at the new location */
            if (args.parentNode) {
                this.parentNode.remove(this.domNode);
                jQuery.extend(this, args);
                this.parentNode.append(this.domNode);
            }
        },
        show: function() {
            this.hide();
            jQuery(this.domNode)
                .addClass("show");
        },
        showWithAnimation: function() {
            this.show();
            jQuery(this.domNode)
                .addClass("animated");
        },
        hide: function() {
            jQuery(this.domNode)
                .removeClass("show animated");
        }
    };
    return Overlay;
});

