define("widgets/Spinner", [
 "widgets/Overlay",
 "plugins/text!widgets/templates/Spinner.html"
], function(Overlay, template) {
    var Spinner = {
        domNode: null,
        parentNode: null,
        overlayParentNode: null,
        initInstance: function(args) {
            if (!this.domNode && !this.parentNode) {
                jQuery.extend(this, args);
                var spinnerTemplate = jQuery(template)
                    .clone();
                this.domNode = jQuery(spinnerTemplate)
                    .get();
                this.parentNode.append(this.domNode);
                Overlay.initInstance({
                    parentNode: this.overlayParentNode || this.parentNode
                });
            }
        },
        updateInstance: function(args) {
            if (args.parentNode) {
                /* remove the spinner from the existing location and place at the new location */
                this.parentNode.remove(this.domNode);
                jQuery.extend(this, args);
                this.parentNode.append(this.domNode);
            }
        },
        show: function() {
            Overlay.show();
            jQuery(this.domNode)
                .addClass("show");
        },
        hide: function() {
            Overlay.hide();
            jQuery(this.domNode)
                .removeClass("show");
        }
    };
    return Spinner;
});

